/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/cloud/audit/audit_log.proto

package org.apache.ratis.thirdparty.com.google.cloud.audit;

/**
 *
 *
 * <pre>
 * Location information about a resource.
 * </pre>
 *
 * Protobuf type {@code google.cloud.audit.ResourceLocation}
 */
public final class ResourceLocation extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.cloud.audit.ResourceLocation)
    ResourceLocationOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use ResourceLocation.newBuilder() to construct.
  private ResourceLocation(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private ResourceLocation() {
    currentLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
    originalLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new ResourceLocation();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private ResourceLocation(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              java.lang.String s = input.readStringRequireUtf8();
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                currentLocations_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000001;
              }
              currentLocations_.add(s);
              break;
            }
          case 18:
            {
              java.lang.String s = input.readStringRequireUtf8();
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                originalLocations_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              originalLocations_.add(s);
              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        currentLocations_ = currentLocations_.getUnmodifiableView();
      }
      if (((mutable_bitField0_ & 0x00000002) != 0)) {
        originalLocations_ = originalLocations_.getUnmodifiableView();
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_ResourceLocation_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_ResourceLocation_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.class,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.Builder.class);
  }

  public static final int CURRENT_LOCATIONS_FIELD_NUMBER = 1;
  private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList currentLocations_;
  /**
   *
   *
   * <pre>
   * The locations of a resource after the execution of the operation.
   * Requests to create or delete a location based resource must populate
   * the 'current_locations' field and not the 'original_locations' field.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string current_locations = 1;</code>
   *
   * @return A list containing the currentLocations.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getCurrentLocationsList() {
    return currentLocations_;
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource after the execution of the operation.
   * Requests to create or delete a location based resource must populate
   * the 'current_locations' field and not the 'original_locations' field.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string current_locations = 1;</code>
   *
   * @return The count of currentLocations.
   */
  public int getCurrentLocationsCount() {
    return currentLocations_.size();
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource after the execution of the operation.
   * Requests to create or delete a location based resource must populate
   * the 'current_locations' field and not the 'original_locations' field.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string current_locations = 1;</code>
   *
   * @param index The index of the element to return.
   * @return The currentLocations at the given index.
   */
  public java.lang.String getCurrentLocations(int index) {
    return currentLocations_.get(index);
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource after the execution of the operation.
   * Requests to create or delete a location based resource must populate
   * the 'current_locations' field and not the 'original_locations' field.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string current_locations = 1;</code>
   *
   * @param index The index of the value to return.
   * @return The bytes of the currentLocations at the given index.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCurrentLocationsBytes(int index) {
    return currentLocations_.getByteString(index);
  }

  public static final int ORIGINAL_LOCATIONS_FIELD_NUMBER = 2;
  private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList originalLocations_;
  /**
   *
   *
   * <pre>
   * The locations of a resource prior to the execution of the operation.
   * Requests that mutate the resource's location must populate both the
   * 'original_locations' as well as the 'current_locations' fields.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string original_locations = 2;</code>
   *
   * @return A list containing the originalLocations.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getOriginalLocationsList() {
    return originalLocations_;
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource prior to the execution of the operation.
   * Requests that mutate the resource's location must populate both the
   * 'original_locations' as well as the 'current_locations' fields.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string original_locations = 2;</code>
   *
   * @return The count of originalLocations.
   */
  public int getOriginalLocationsCount() {
    return originalLocations_.size();
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource prior to the execution of the operation.
   * Requests that mutate the resource's location must populate both the
   * 'original_locations' as well as the 'current_locations' fields.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string original_locations = 2;</code>
   *
   * @param index The index of the element to return.
   * @return The originalLocations at the given index.
   */
  public java.lang.String getOriginalLocations(int index) {
    return originalLocations_.get(index);
  }
  /**
   *
   *
   * <pre>
   * The locations of a resource prior to the execution of the operation.
   * Requests that mutate the resource's location must populate both the
   * 'original_locations' as well as the 'current_locations' fields.
   * For example:
   *     "europe-west1-a"
   *     "us-east1"
   *     "nam3"
   * </pre>
   *
   * <code>repeated string original_locations = 2;</code>
   *
   * @param index The index of the value to return.
   * @return The bytes of the originalLocations at the given index.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getOriginalLocationsBytes(int index) {
    return originalLocations_.getByteString(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < currentLocations_.size(); i++) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, currentLocations_.getRaw(i));
    }
    for (int i = 0; i < originalLocations_.size(); i++) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 2, originalLocations_.getRaw(i));
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    {
      int dataSize = 0;
      for (int i = 0; i < currentLocations_.size(); i++) {
        dataSize += computeStringSizeNoTag(currentLocations_.getRaw(i));
      }
      size += dataSize;
      size += 1 * getCurrentLocationsList().size();
    }
    {
      int dataSize = 0;
      for (int i = 0; i < originalLocations_.size(); i++) {
        dataSize += computeStringSizeNoTag(originalLocations_.getRaw(i));
      }
      size += dataSize;
      size += 1 * getOriginalLocationsList().size();
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation other = (org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation) obj;

    if (!getCurrentLocationsList().equals(other.getCurrentLocationsList())) return false;
    if (!getOriginalLocationsList().equals(other.getOriginalLocationsList())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getCurrentLocationsCount() > 0) {
      hash = (37 * hash) + CURRENT_LOCATIONS_FIELD_NUMBER;
      hash = (53 * hash) + getCurrentLocationsList().hashCode();
    }
    if (getOriginalLocationsCount() > 0) {
      hash = (37 * hash) + ORIGINAL_LOCATIONS_FIELD_NUMBER;
      hash = (53 * hash) + getOriginalLocationsList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseDelimitedFrom(
      java.io.InputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Location information about a resource.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.ResourceLocation}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.cloud.audit.ResourceLocation)
      org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocationOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ResourceLocation_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ResourceLocation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      currentLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000001);
      originalLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000002);
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ResourceLocation_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation build() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation buildPartial() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation result =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation(this);
      int from_bitField0_ = bitField0_;
      if (((bitField0_ & 0x00000001) != 0)) {
        currentLocations_ = currentLocations_.getUnmodifiableView();
        bitField0_ = (bitField0_ & ~0x00000001);
      }
      result.currentLocations_ = currentLocations_;
      if (((bitField0_ & 0x00000002) != 0)) {
        originalLocations_ = originalLocations_.getUnmodifiableView();
        bitField0_ = (bitField0_ & ~0x00000002);
      }
      result.originalLocations_ = originalLocations_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation other) {
      if (other == org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation.getDefaultInstance()) return this;
      if (!other.currentLocations_.isEmpty()) {
        if (currentLocations_.isEmpty()) {
          currentLocations_ = other.currentLocations_;
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          ensureCurrentLocationsIsMutable();
          currentLocations_.addAll(other.currentLocations_);
        }
        onChanged();
      }
      if (!other.originalLocations_.isEmpty()) {
        if (originalLocations_.isEmpty()) {
          originalLocations_ = other.originalLocations_;
          bitField0_ = (bitField0_ & ~0x00000002);
        } else {
          ensureOriginalLocationsIsMutable();
          originalLocations_.addAll(other.originalLocations_);
        }
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int bitField0_;

    private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList currentLocations_ =
        org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;

    private void ensureCurrentLocationsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        currentLocations_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList(currentLocations_);
        bitField0_ |= 0x00000001;
      }
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @return A list containing the currentLocations.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getCurrentLocationsList() {
      return currentLocations_.getUnmodifiableView();
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @return The count of currentLocations.
     */
    public int getCurrentLocationsCount() {
      return currentLocations_.size();
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param index The index of the element to return.
     * @return The currentLocations at the given index.
     */
    public java.lang.String getCurrentLocations(int index) {
      return currentLocations_.get(index);
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the currentLocations at the given index.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCurrentLocationsBytes(int index) {
      return currentLocations_.getByteString(index);
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param index The index to set the value at.
     * @param value The currentLocations to set.
     * @return This builder for chaining.
     */
    public Builder setCurrentLocations(int index, java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureCurrentLocationsIsMutable();
      currentLocations_.set(index, value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param value The currentLocations to add.
     * @return This builder for chaining.
     */
    public Builder addCurrentLocations(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureCurrentLocationsIsMutable();
      currentLocations_.add(value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param values The currentLocations to add.
     * @return This builder for chaining.
     */
    public Builder addAllCurrentLocations(java.lang.Iterable<java.lang.String> values) {
      ensureCurrentLocationsIsMutable();
      org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, currentLocations_);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearCurrentLocations() {
      currentLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource after the execution of the operation.
     * Requests to create or delete a location based resource must populate
     * the 'current_locations' field and not the 'original_locations' field.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string current_locations = 1;</code>
     *
     * @param value The bytes of the currentLocations to add.
     * @return This builder for chaining.
     */
    public Builder addCurrentLocationsBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      ensureCurrentLocationsIsMutable();
      currentLocations_.add(value);
      onChanged();
      return this;
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList originalLocations_ =
        org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;

    private void ensureOriginalLocationsIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        originalLocations_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList(originalLocations_);
        bitField0_ |= 0x00000002;
      }
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @return A list containing the originalLocations.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getOriginalLocationsList() {
      return originalLocations_.getUnmodifiableView();
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @return The count of originalLocations.
     */
    public int getOriginalLocationsCount() {
      return originalLocations_.size();
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param index The index of the element to return.
     * @return The originalLocations at the given index.
     */
    public java.lang.String getOriginalLocations(int index) {
      return originalLocations_.get(index);
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the originalLocations at the given index.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getOriginalLocationsBytes(int index) {
      return originalLocations_.getByteString(index);
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param index The index to set the value at.
     * @param value The originalLocations to set.
     * @return This builder for chaining.
     */
    public Builder setOriginalLocations(int index, java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureOriginalLocationsIsMutable();
      originalLocations_.set(index, value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param value The originalLocations to add.
     * @return This builder for chaining.
     */
    public Builder addOriginalLocations(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureOriginalLocationsIsMutable();
      originalLocations_.add(value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param values The originalLocations to add.
     * @return This builder for chaining.
     */
    public Builder addAllOriginalLocations(java.lang.Iterable<java.lang.String> values) {
      ensureOriginalLocationsIsMutable();
      org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, originalLocations_);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearOriginalLocations() {
      originalLocations_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000002);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The locations of a resource prior to the execution of the operation.
     * Requests that mutate the resource's location must populate both the
     * 'original_locations' as well as the 'current_locations' fields.
     * For example:
     *     "europe-west1-a"
     *     "us-east1"
     *     "nam3"
     * </pre>
     *
     * <code>repeated string original_locations = 2;</code>
     *
     * @param value The bytes of the originalLocations to add.
     * @return This builder for chaining.
     */
    public Builder addOriginalLocationsBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      ensureOriginalLocationsIsMutable();
      originalLocations_.add(value);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.audit.ResourceLocation)
  }

  // @@protoc_insertion_point(class_scope:google.cloud.audit.ResourceLocation)
  private static final org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation();
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<ResourceLocation> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<ResourceLocation>() {
        @java.lang.Override
        public ResourceLocation parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new ResourceLocation(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<ResourceLocation> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<ResourceLocation> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ResourceLocation getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
